<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>LibArch: src/lib_datatrans.h Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">LibArch
   </div>
   <div id="projectbrief">Library architecture and framework</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Macros</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">lib_datatrans.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../db/d64/lib__datatrans_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2015-2017, Texas Instruments Incorporated - http://www.ti.com</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *   All rights reserved.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *   Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *   modification, are permitted provided that the following conditions are met:</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *       * Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *         notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *       * Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *         notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *         documentation and/or other materials provided with the distribution.</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *       * Neither the name of Texas Instruments Incorporated nor the</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *         names of its contributors may be used to endorse or promote products</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *         derived from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *   THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> *****************************************************************************/</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#ifndef _LIBARCH_DATA_TRANS_H</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define _LIBARCH_DATA_TRANS_H</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment">/* LibArch data transfer API is built on top of CSL and EdmaMgr for K2H, C6678, </span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment">   and AM572x, but on top of CSL and EDMA3 LLD for K2G. Future work will be </span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment">   replacing EdmaMgr with EDMA3 LLD for all supported platforms. */</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef SOC_K2G</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#include &lt;ti/sdo/fc/edmamgr/edmamgr.h&gt;</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#include &lt;ti/sdo/edma3/drv/edma3_drv.h&gt;</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;ti/csl/csl_chipAux.h&gt;</span> </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;ti/csl/csl_idmaAux.h&gt;</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="../../dc/da2/lib__utils_8h.html">lib_utils.h</a>&quot;</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div>
<div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga0e8d22819c818e39a2bae0ea24bb567b">   82</a></span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga0e8d22819c818e39a2bae0ea24bb567b">lib_imt_copy</a>(<span class="keyword">const</span> <span class="keywordtype">void</span> *src, <span class="keywordtype">void</span> *dst, <span class="keywordtype">size_t</span> size)</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;{</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;  <span class="comment">/* use volatile to prevent compiler from optimizing away subsequent reads */</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;  <span class="keyword">volatile</span> uint32_t pend;  </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;  </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;  <span class="comment">/* wait untill there is no pending transfer */</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;  <span class="keywordflow">while</span>( (pend = CSL_FEXT(hIdma-&gt;IDMA1_STAT, CGEM_IDMA1_STAT_PEND) ) );</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;  </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="comment">/* hard code the following configuration:</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment">     - Block fill: 0</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment">     - DSP interrupt enable: 0</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment">     - Transfer priority: 7 (lowest)</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="comment">  */</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;  hIdma-&gt;IDMA1_SOURCE  = (uint32_t)src;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  hIdma-&gt;IDMA1_DEST    = (uint32_t)dst; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;  hIdma-&gt;IDMA1_COUNT   = CSL_FMK(CGEM_IDMA1_COUNT_PRI,   (uint32_t)7) |</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;                         CSL_FMK(CGEM_IDMA1_COUNT_INT,   (uint32_t)0) |</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;                         CSL_FMK(CGEM_IDMA1_COUNT_FILL,  (uint32_t)0) |</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;                         CSL_FMK(CGEM_IDMA1_COUNT_COUNT, size);</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;  <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;}</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga8189ff38ebc25a3700ab04ffb612b1f2">  118</a></span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga8189ff38ebc25a3700ab04ffb612b1f2">lib_imt_set</a>(uint32_t pattern, <span class="keywordtype">void</span> *dst, <span class="keywordtype">size_t</span> size)</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;{</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;  <span class="comment">/* use volatile to prevent compiler from optimizing away subsequent reads */</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;  <span class="keyword">volatile</span> uint32_t pend;  </div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;  </div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;  <span class="comment">/* wait untill there is no pending transfer */</span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;  <span class="keywordflow">while</span>( (pend = CSL_FEXT(hIdma-&gt;IDMA1_STAT, CGEM_IDMA1_STAT_PEND) ) );</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;  </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;  <span class="comment">/* hard code the following configuration:</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="comment">     - Block fill: 1</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="comment">     - DSP interrupt enable: 0</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="comment">     - Transfer priority: 7 (lowest)</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="comment">  */</span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;  hIdma-&gt;IDMA1_SOURCE  = pattern;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;  hIdma-&gt;IDMA1_DEST    = (uint32_t)dst; </div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;  hIdma-&gt;IDMA1_COUNT   = CSL_FMK(CGEM_IDMA1_COUNT_PRI,   (uint32_t)7) |</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;                         CSL_FMK(CGEM_IDMA1_COUNT_INT,   (uint32_t)0) |</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;                         CSL_FMK(CGEM_IDMA1_COUNT_FILL,  (uint32_t)1) |</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;                         CSL_FMK(CGEM_IDMA1_COUNT_COUNT, size);  </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;  <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;}</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div>
<div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga320847c84fb1dd50ce67a1f5c5315043">  149</a></span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga320847c84fb1dd50ce67a1f5c5315043">lib_imt_wait</a>() </div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;{</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;  CSL_IDMA_chan1Wait();</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;}</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div>
<div class="line"><a name="l00160"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga6682ba347b624952140c5ead3301a8be">  160</a></span>&#160;<span class="preprocessor">#define LIB_EMT_SUCCESS          (0)   </span></div>
<div class="line"><a name="l00161"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga7c00744552e888fa1c1da7bafc3fb362">  161</a></span>&#160;<span class="preprocessor">#define LIB_EMT_ERROR_INVARG     (-1)  </span></div>
<div class="line"><a name="l00162"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#gaec3d5fb167114b1c4dbf5d3a6220b0d1">  162</a></span>&#160;<span class="preprocessor">#define LIB_EMT_ERROR_INVCFG     (-2)  </span></div>
<div class="line"><a name="l00163"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga9189f70619c7a767d69d7fe8b9500e7e">  163</a></span>&#160;<span class="preprocessor">#define LIB_EMT_ERROR_RMANINIT   (-3)  </span></div>
<div class="line"><a name="l00164"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga7ca25bc939f597f627bc633b7256c05e">  164</a></span>&#160;<span class="preprocessor">#define LIB_EMT_ERROR_INVHANDLE  (-4)  </span></div>
<div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga5262fd9542b2a9beb4f9b6a7c1215a95">  165</a></span>&#160;<span class="preprocessor">#define LIB_EMT_ERROR_FREE       (-5)  </span></div>
<div class="line"><a name="l00166"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga25622242e06ac967497797f20e3095dd">  166</a></span>&#160;<span class="preprocessor">#define LIB_EMT_ERROR_XFER       (-6)  </span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00169"></a><span class="lineno"><a class="line" href="../../db/d64/lib__datatrans_8h.html#a4e88f54a58fca935d1017e62bdfa4e39">  169</a></span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define LIB_EMT_MAX_PAR_CHANNELS 8  </span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="preprocessor">#define LIB_EMT_MAX_NUM_CHANNELS 32 </span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="preprocessor">typedef void * lib_emt_Handle;      </span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="../../dd/da7/structlib__emt__Config__s.html">lib_emt_Config_s</a></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;{</div>
<div class="line"><a name="l00190"></a><span class="lineno"><a class="line" href="../../dd/da7/structlib__emt__Config__s.html">  190</a></span>&#160;    EDMA3_DRV_Handle <a class="code" href="../../dd/da7/structlib__emt__Config__s.html#a107a877058872e7f6761beb8af68b977">hEdma</a>;  </div>
<div class="line"><a name="l00192"></a><span class="lineno"><a class="line" href="../../dd/da7/structlib__emt__Config__s.html#a107a877058872e7f6761beb8af68b977">  192</a></span>&#160;} <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga22177ad0d4d825d5ed3b26021634b221">lib_emt_Config_t</a>;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="../../d8/d98/structlib__emt__ConfigLarge__s.html">lib_emt_ConfigLarge_s</a></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;{</div>
<div class="line"><a name="l00204"></a><span class="lineno"><a class="line" href="../../d8/d98/structlib__emt__ConfigLarge__s.html">  204</a></span>&#160;  int32_t <a class="code" href="../../d8/d98/structlib__emt__ConfigLarge__s.html#a0663257ebd151a0deda386e4b3a3bf48">max_num_lines</a>;   </div>
<div class="line"><a name="l00206"></a><span class="lineno"><a class="line" href="../../d8/d98/structlib__emt__ConfigLarge__s.html#a0663257ebd151a0deda386e4b3a3bf48">  206</a></span>&#160;} <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga437bfecb0c8f550b36bae0f0ee65702d">lib_emt_ConfigLarge_t</a>;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="preprocessor"></span><span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga40fa4887611b6ceb4d57b9804d6b26fb">lib_emt_init</a>(<a class="code" href="../../dd/da7/structlib__emt__Config__s.html">lib_emt_Config_t</a> *cfg);</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">int</span> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga40fa4887611b6ceb4d57b9804d6b26fb">lib_emt_init</a>()</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;{    </div>
<div class="line"><a name="l00224"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga40fa4887611b6ceb4d57b9804d6b26fb">  224</a></span>&#160;<span class="preprocessor">#ifdef LIB_OPENCL </span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="preprocessor"></span><span class="comment">/* OpenCL monitor calls EdmaMgr_init during initialization prior to any kernels </span></div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;<span class="comment">   being offloaded to DSP. So kernel code doesn&#39;t need to call edmaMgr_init.</span></div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="comment">*/</span></div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;  <span class="keywordflow">return</span>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga6682ba347b624952140c5ead3301a8be">LIB_EMT_SUCCESS</a>);</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#  ifdef LIB_RTOS</span></div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="preprocessor"></span>     <span class="keywordflow">return</span>(EdmaMgr_init(<a class="code" href="../../de/d6b/group__libarch__utils.html#ga2dc4317fe6b9d654c7ec71eba4704bcd">lib_get_coreID</a>(), NULL));</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;<span class="preprocessor">#  else</span></div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#    error &quot;Unsupported OS! Please specify either LIB_OPENCL or LIB_RTOS&quot;</span></div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#  endif</span></div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#endif   </span></div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="preprocessor"></span>}</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;<span class="preprocessor"></span><span class="keyword">extern</span> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc">lib_emt_alloc</a>(int32_t max_linked_transfers);</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc">lib_emt_alloc</a>(int32_t max_linked_transfers)</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;{</div>
<div class="line"><a name="l00260"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc">  260</a></span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_alloc(max_linked_transfers));</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;}</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;<span class="preprocessor"></span><span class="comment">/* function lib_emt_allocLarge to be added for K2G in future */</span></div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed">lib_emt_allocLarge</a>(<a class="code" href="../../d8/d98/structlib__emt__ConfigLarge__s.html">lib_emt_ConfigLarge_t</a> *cfg, </div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;                                  IALG_MemRec *memTab)</div>
<div class="line"><a name="l00290"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed">  290</a></span>&#160;{</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_allocLarge((EdmaMgr_ConfigLarge *)cfg, memTab));</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;}</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;<span class="preprocessor"></span><span class="comment">/* function lib_emt_getSizesLarge to be added for K2G in future */</span></div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga01f4f02c995d8842a1b172670a97dc80">lib_emt_getSizesLarge</a>(<a class="code" href="../../d8/d98/structlib__emt__ConfigLarge__s.html">lib_emt_ConfigLarge_t</a> *cfg, </div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;                                            IALG_MemRec *memTab)</div>
<div class="line"><a name="l00318"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga01f4f02c995d8842a1b172670a97dc80">  318</a></span>&#160;{</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_getSizesLarge((EdmaMgr_ConfigLarge *)cfg, memTab));</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;}</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;<span class="preprocessor"></span><span class="keyword">extern</span> int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga97f5256765c92ada94fed76df35da8f8">lib_emt_free</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h);</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga97f5256765c92ada94fed76df35da8f8">lib_emt_free</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h)</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;{</div>
<div class="line"><a name="l00342"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga97f5256765c92ada94fed76df35da8f8">  342</a></span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_free(h));</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;}</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;<span class="preprocessor"></span><span class="keyword">extern</span> int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gadfa5407c4b9d573f3f67d072f8ee76da">lib_emt_wait</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h);</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gadfa5407c4b9d573f3f67d072f8ee76da">lib_emt_wait</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h)</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;{</div>
<div class="line"><a name="l00364"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#gadfa5407c4b9d573f3f67d072f8ee76da">  364</a></span>&#160;  EdmaMgr_wait(h);</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;  <span class="keywordflow">return</span>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga6682ba347b624952140c5ead3301a8be">LIB_EMT_SUCCESS</a>);  </div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;}</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;<span class="preprocessor"></span><span class="keyword">extern</span> int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gabe9856fed82fa0fc911a9fdb43e494e1">lib_emt_copy1D1D</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src, </div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;                                <span class="keywordtype">void</span> *restrict dst, int32_t num_bytes);</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gabe9856fed82fa0fc911a9fdb43e494e1">lib_emt_copy1D1D</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src, </div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;                          <span class="keywordtype">void</span> *restrict dst, int32_t num_bytes)</div>
<div class="line"><a name="l00400"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#gabe9856fed82fa0fc911a9fdb43e494e1">  400</a></span>&#160;{</div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy1D1D(h,src,dst,num_bytes));</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;}                                        </div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;<span class="preprocessor"></span> </div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;<span class="preprocessor"></span><span class="comment">/* function lib_emt_copy1D2D to be added for K2G in future */</span></div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga7eac2e886fc99a5be1086cb0fa6d9d4e">lib_emt_copy1D2D</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src, <span class="keywordtype">void</span> *restrict dst, </div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;                          int32_t num_bytes, int32_t num_lines, int32_t pitch)</div>
<div class="line"><a name="l00433"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga7eac2e886fc99a5be1086cb0fa6d9d4e">  433</a></span>&#160;{</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy1D2D(h,src,dst,num_bytes,num_lines,pitch));</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;} </div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;<span class="preprocessor"></span><span class="comment">/* function lib_emt_copy2D1D to be added for K2G in future */</span></div>
<div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gab6426d5afb67b7e9b4a8cff88135ab3f">lib_emt_copy2D1D</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src, <span class="keywordtype">void</span> *restrict dst, </div>
<div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;                          int32_t num_bytes, int32_t num_lines, int32_t pitch)</div>
<div class="line"><a name="l00466"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#gab6426d5afb67b7e9b4a8cff88135ab3f">  466</a></span>&#160;{</div>
<div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy2D1D(h,src,dst,num_bytes,num_lines,pitch));</div>
<div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;} </div>
<div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;<span class="preprocessor">#ifdef SOC_K2G</span></div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;<span class="preprocessor"></span><span class="keyword">extern</span> int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga624053012144128867ef2a9ef808f264">lib_emt_copy2D2D</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src, <span class="keywordtype">void</span> *restrict dst, </div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;                                int32_t num_bytes, int32_t num_lines, int32_t src_pitch, </div>
<div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;                                int32_t dst_pitch);</div>
<div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;<span class="preprocessor">#else  </span><span class="comment">/* not SOC_K2G */</span><span class="preprocessor">   </span></div>
<div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;<span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga624053012144128867ef2a9ef808f264">lib_emt_copy2D2D</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src, <span class="keywordtype">void</span> *restrict dst, </div>
<div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;                          int32_t num_bytes, int32_t num_lines, int32_t src_pitch, </div>
<div class="line"><a name="l00504"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga624053012144128867ef2a9ef808f264">  504</a></span>&#160;                          int32_t dst_pitch)</div>
<div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;{</div>
<div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy2D2DSep(h,src,dst,num_bytes,num_lines,src_pitch,dst_pitch));</div>
<div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;}</div>
<div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;<span class="preprocessor">#ifndef SOC_K2G</span></div>
<div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;<span class="preprocessor"></span><span class="comment">/* following functions are to be added for K2G in future */</span></div>
<div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga5f4e571bc160df4f1ccf934aaeaa325b">lib_emt_copy1D1DLinked</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src[], </div>
<div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;                                <span class="keywordtype">void</span> *restrict dst[], int32_t num_bytes[], </div>
<div class="line"><a name="l00532"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga5f4e571bc160df4f1ccf934aaeaa325b">  532</a></span>&#160;                                int32_t num_transfers)</div>
<div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;{</div>
<div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy1D1DLinked(h,src,dst,num_bytes,num_transfers));</div>
<div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;}</div>
<div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160; </div>
<div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gaa0783528473328cd5a809bd528bea150">lib_emt_copy1D2DLinked</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src[], </div>
<div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;                                <span class="keywordtype">void</span> *restrict dst[], int32_t num_bytes[], </div>
<div class="line"><a name="l00559"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#gaa0783528473328cd5a809bd528bea150">  559</a></span>&#160;                                int32_t num_lines[], int32_t pitch[], </div>
<div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;                                int32_t num_transfers)</div>
<div class="line"><a name="l00561"></a><span class="lineno">  561</span>&#160;{</div>
<div class="line"><a name="l00562"></a><span class="lineno">  562</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy1D2DLinked(h,src,dst,num_bytes,num_lines,pitch,num_transfers));</div>
<div class="line"><a name="l00563"></a><span class="lineno">  563</span>&#160;} </div>
<div class="line"><a name="l00564"></a><span class="lineno">  564</span>&#160;</div>
<div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gaae7bb385b41241410af0b5e917158e7b">lib_emt_copy2D1DLinked</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src[], </div>
<div class="line"><a name="l00586"></a><span class="lineno">  586</span>&#160;                                <span class="keywordtype">void</span> *restrict dst[], int32_t num_bytes[], </div>
<div class="line"><a name="l00587"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#gaae7bb385b41241410af0b5e917158e7b">  587</a></span>&#160;                                int32_t num_lines[], int32_t pitch[], </div>
<div class="line"><a name="l00588"></a><span class="lineno">  588</span>&#160;                                int32_t num_transfers)</div>
<div class="line"><a name="l00589"></a><span class="lineno">  589</span>&#160;{</div>
<div class="line"><a name="l00590"></a><span class="lineno">  590</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy2D1DLinked(h,src,dst,num_bytes,num_lines,pitch,num_transfers));</div>
<div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160;}</div>
<div class="line"><a name="l00592"></a><span class="lineno">  592</span>&#160; </div>
<div class="line"><a name="l00613"></a><span class="lineno">  613</span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00614"></a><span class="lineno">  614</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gaef9d8b5dd3d94847af102329ead8a081">lib_emt_copy2D2DLinked</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src[], </div>
<div class="line"><a name="l00615"></a><span class="lineno">  615</span>&#160;                                <span class="keywordtype">void</span> *restrict dst[], int32_t num_bytes[], </div>
<div class="line"><a name="l00616"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#gaef9d8b5dd3d94847af102329ead8a081">  616</a></span>&#160;                                int32_t num_lines[], int32_t src_pitch[], </div>
<div class="line"><a name="l00617"></a><span class="lineno">  617</span>&#160;                                int32_t dst_pitch[], int32_t num_transfers)</div>
<div class="line"><a name="l00618"></a><span class="lineno">  618</span>&#160;{</div>
<div class="line"><a name="l00619"></a><span class="lineno">  619</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy2D2DSepLinked(h,src,dst,num_bytes,num_lines,src_pitch,</div>
<div class="line"><a name="l00620"></a><span class="lineno">  620</span>&#160;                                   dst_pitch,num_transfers));</div>
<div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;} </div>
<div class="line"><a name="l00622"></a><span class="lineno">  622</span>&#160;</div>
<div class="line"><a name="l00650"></a><span class="lineno">  650</span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00651"></a><span class="lineno">  651</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga1a987a6a5bddf31afc70ce6a0fbd17e1">lib_emt_copy1D2DLarge</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src, </div>
<div class="line"><a name="l00652"></a><span class="lineno">  652</span>&#160;                               <span class="keywordtype">void</span> *restrict dst, int32_t num_bytes, </div>
<div class="line"><a name="l00653"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#ga1a987a6a5bddf31afc70ce6a0fbd17e1">  653</a></span>&#160;                               int32_t num_lines, int32_t pitch)</div>
<div class="line"><a name="l00654"></a><span class="lineno">  654</span>&#160;{</div>
<div class="line"><a name="l00655"></a><span class="lineno">  655</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy1D2DLarge(h,src,dst,num_bytes,num_lines,pitch));</div>
<div class="line"><a name="l00656"></a><span class="lineno">  656</span>&#160;}</div>
<div class="line"><a name="l00657"></a><span class="lineno">  657</span>&#160; </div>
<div class="line"><a name="l00685"></a><span class="lineno">  685</span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> </div>
<div class="line"><a name="l00686"></a><span class="lineno">  686</span>&#160;int32_t <a class="code" href="../../d1/df3/group__libarch__datatrans.html#gab1b291a6ce214301ed50b5731590e29a">lib_emt_copy2D1DLarge</a>(<a class="code" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, <span class="keywordtype">void</span> *restrict src, </div>
<div class="line"><a name="l00687"></a><span class="lineno">  687</span>&#160;                               <span class="keywordtype">void</span> *restrict dst, int32_t num_bytes, </div>
<div class="line"><a name="l00688"></a><span class="lineno"><a class="line" href="../../d1/df3/group__libarch__datatrans.html#gab1b291a6ce214301ed50b5731590e29a">  688</a></span>&#160;                               int32_t num_lines, int32_t pitch)</div>
<div class="line"><a name="l00689"></a><span class="lineno">  689</span>&#160;{</div>
<div class="line"><a name="l00690"></a><span class="lineno">  690</span>&#160;  <span class="keywordflow">return</span>(EdmaMgr_copy2D1DLarge(h,src,dst,num_bytes,num_lines,pitch));</div>
<div class="line"><a name="l00691"></a><span class="lineno">  691</span>&#160;} </div>
<div class="line"><a name="l00692"></a><span class="lineno">  692</span>&#160;</div>
<div class="line"><a name="l00693"></a><span class="lineno">  693</span>&#160;<span class="comment">/* EdmaMgr APIs listed below are not mapped to LibArch APIs:</span></div>
<div class="line"><a name="l00694"></a><span class="lineno">  694</span>&#160;<span class="comment">int32_t EdmaMgr_copy2D2D(EdmaMgr_Handle h, void *restrict src, void *restrict dst, </span></div>
<div class="line"><a name="l00695"></a><span class="lineno">  695</span>&#160;<span class="comment">                         int32_t num_bytes, int32_t num_lines, int32_t pitch);</span></div>
<div class="line"><a name="l00696"></a><span class="lineno">  696</span>&#160;<span class="comment">int32_t EdmaMgr_copy2D2DLinked(EdmaMgr_Handle h, void *restrict src[], </span></div>
<div class="line"><a name="l00697"></a><span class="lineno">  697</span>&#160;<span class="comment">                               void *restrict dst[], int32_t num_bytes[], </span></div>
<div class="line"><a name="l00698"></a><span class="lineno">  698</span>&#160;<span class="comment">                               int32_t num_lines[], int32_t pitch[], </span></div>
<div class="line"><a name="l00699"></a><span class="lineno">  699</span>&#160;<span class="comment">                               int32_t num_transfers);</span></div>
<div class="line"><a name="l00700"></a><span class="lineno">  700</span>&#160;<span class="comment">int32_t EdmaMgr_copyFast(EdmaMgr_Handle h, void *restrict src, void *restrict dst);</span></div>
<div class="line"><a name="l00701"></a><span class="lineno">  701</span>&#160;<span class="comment">int32_t EdmaMgr_copyLinkedFast(EdmaMgr_Handle h, void *restrict src[], </span></div>
<div class="line"><a name="l00702"></a><span class="lineno">  702</span>&#160;<span class="comment">                               void *restrict dst[], int32_t num_transfers);</span></div>
<div class="line"><a name="l00703"></a><span class="lineno">  703</span>&#160;<span class="comment">*/</span></div>
<div class="line"><a name="l00704"></a><span class="lineno">  704</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* end of non SOC_K2G */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00705"></a><span class="lineno">  705</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00706"></a><span class="lineno">  706</span>&#160;<span class="preprocessor">#endif </span></div>
<div class="ttc" id="structlib__emt__Config__s_html"><div class="ttname"><a href="../../dd/da7/structlib__emt__Config__s.html">lib_emt_Config_s</a></div><div class="ttdoc">Configuration parameters for the initialization of external memory data transfer. ...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:190</div></div>
<div class="ttc" id="group__libarch__datatrans_html_gadfa5407c4b9d573f3f67d072f8ee76da"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#gadfa5407c4b9d573f3f67d072f8ee76da">lib_emt_wait</a></div><div class="ttdeci">static int32_t lib_emt_wait(lib_emt_Handle h)</div><div class="ttdoc">Function lib_emt_wait waits for completion of external transfers started by lib_emt_copyxxx. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:364</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga5f4e571bc160df4f1ccf934aaeaa325b"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga5f4e571bc160df4f1ccf934aaeaa325b">lib_emt_copy1D1DLinked</a></div><div class="ttdeci">static int32_t lib_emt_copy1D1DLinked(lib_emt_Handle h, void *restrict src[], void *restrict dst[], int32_t num_bytes[], int32_t num_transfers)</div><div class="ttdoc">Function lib_emt_copy1D1DLinked performs a group of linked 1D-&gt;1D transfers. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:532</div></div>
<div class="ttc" id="group__libarch__datatrans_html_gab1b291a6ce214301ed50b5731590e29a"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#gab1b291a6ce214301ed50b5731590e29a">lib_emt_copy2D1DLarge</a></div><div class="ttdeci">static int32_t lib_emt_copy2D1DLarge(lib_emt_Handle h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t pitch)</div><div class="ttdoc">Function lib_emt_copy2D1DLarge performs a 2D-&gt;1D transfer when source pitch is large (outside the ran...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:688</div></div>
<div class="ttc" id="group__libarch__datatrans_html_gaa0783528473328cd5a809bd528bea150"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#gaa0783528473328cd5a809bd528bea150">lib_emt_copy1D2DLinked</a></div><div class="ttdeci">static int32_t lib_emt_copy1D2DLinked(lib_emt_Handle h, void *restrict src[], void *restrict dst[], int32_t num_bytes[], int32_t num_lines[], int32_t pitch[], int32_t num_transfers)</div><div class="ttdoc">Function lib_emt_copy1D2DLinked performs a group of linked 1D-&gt;2D transfers. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:559</div></div>
<div class="ttc" id="group__libarch__datatrans_html_gab6426d5afb67b7e9b4a8cff88135ab3f"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#gab6426d5afb67b7e9b4a8cff88135ab3f">lib_emt_copy2D1D</a></div><div class="ttdeci">static int32_t lib_emt_copy2D1D(lib_emt_Handle h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t pitch)</div><div class="ttdoc">Function lib_emt_copy2D1D performs a 2D-&gt;1D transfer. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:466</div></div>
<div class="ttc" id="group__libarch__datatrans_html_gad8adc89232fa208dc86267a4885170ed"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed">lib_emt_allocLarge</a></div><div class="ttdeci">static lib_emt_Handle lib_emt_allocLarge(lib_emt_ConfigLarge_t *cfg, IALG_MemRec *memTab)</div><div class="ttdoc">Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:290</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga22177ad0d4d825d5ed3b26021634b221"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga22177ad0d4d825d5ed3b26021634b221">lib_emt_Config_t</a></div><div class="ttdeci">struct lib_emt_Config_s lib_emt_Config_t</div><div class="ttdoc">Configuration parameters for the initialization of external memory data transfer. ...</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga437bfecb0c8f550b36bae0f0ee65702d"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga437bfecb0c8f550b36bae0f0ee65702d">lib_emt_ConfigLarge_t</a></div><div class="ttdeci">struct lib_emt_ConfigLarge_s lib_emt_ConfigLarge_t</div><div class="ttdoc">Configuration for large external memory data transfers. </div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga3ee110c7c5d95cfe386b113d2d078ec3"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a></div><div class="ttdeci">void * lib_emt_Handle</div><div class="ttdoc">Handle to an external memory data transfer instance. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:181</div></div>
<div class="ttc" id="structlib__emt__Config__s_html_a107a877058872e7f6761beb8af68b977"><div class="ttname"><a href="../../dd/da7/structlib__emt__Config__s.html#a107a877058872e7f6761beb8af68b977">lib_emt_Config_s::hEdma</a></div><div class="ttdeci">EDMA3_DRV_Handle hEdma</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:192</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga0e8d22819c818e39a2bae0ea24bb567b"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga0e8d22819c818e39a2bae0ea24bb567b">lib_imt_copy</a></div><div class="ttdeci">static void lib_imt_copy(const void *src, void *dst, size_t size)</div><div class="ttdoc">Function lib_imt_copy performs data transfers between any two internal memory locations local to the ...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:82</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga97f5256765c92ada94fed76df35da8f8"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga97f5256765c92ada94fed76df35da8f8">lib_emt_free</a></div><div class="ttdeci">static int32_t lib_emt_free(lib_emt_Handle h)</div><div class="ttdoc">Function lib_emt_free frees a channel previously allocated for external memory data transfers...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:342</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga7eac2e886fc99a5be1086cb0fa6d9d4e"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga7eac2e886fc99a5be1086cb0fa6d9d4e">lib_emt_copy1D2D</a></div><div class="ttdeci">static int32_t lib_emt_copy1D2D(lib_emt_Handle h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t pitch)</div><div class="ttdoc">Function lib_emt_copy1D2D performs a 1D-&gt;2D transfer. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:433</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga01f4f02c995d8842a1b172670a97dc80"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga01f4f02c995d8842a1b172670a97dc80">lib_emt_getSizesLarge</a></div><div class="ttdeci">static int32_t lib_emt_getSizesLarge(lib_emt_ConfigLarge_t *cfg, IALG_MemRec *memTab)</div><div class="ttdoc">Function lib_emt_getSizesLarge gets buffer requirements for a channel used to do large transfers...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:318</div></div>
<div class="ttc" id="lib__utils_8h_html"><div class="ttname"><a href="../../dc/da2/lib__utils_8h.html">lib_utils.h</a></div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga2d74d954ddeabe505cdc1caf5fc775bc"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc">lib_emt_alloc</a></div><div class="ttdeci">static lib_emt_Handle lib_emt_alloc(int32_t max_linked_transfers)</div><div class="ttdoc">Function lib_emt_alloc allocates a channel to do external memory data transfers. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:260</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga320847c84fb1dd50ce67a1f5c5315043"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga320847c84fb1dd50ce67a1f5c5315043">lib_imt_wait</a></div><div class="ttdeci">static void lib_imt_wait()</div><div class="ttdoc">Function lib_imt_wait waits for completion of transfers started by lib_imt_copy or lib_imt_set...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:149</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga1a987a6a5bddf31afc70ce6a0fbd17e1"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga1a987a6a5bddf31afc70ce6a0fbd17e1">lib_emt_copy1D2DLarge</a></div><div class="ttdeci">static int32_t lib_emt_copy1D2DLarge(lib_emt_Handle h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t pitch)</div><div class="ttdoc">Function lib_emt_copy1D2DLarge performs a 1D-&gt;2D transfer when destination pitch is large (outside th...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:653</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga40fa4887611b6ceb4d57b9804d6b26fb"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga40fa4887611b6ceb4d57b9804d6b26fb">lib_emt_init</a></div><div class="ttdeci">static int lib_emt_init()</div><div class="ttdoc">Function lib_emt_init performs all necessary initialization for external memory data transfers...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:224</div></div>
<div class="ttc" id="group__libarch__datatrans_html_gaef9d8b5dd3d94847af102329ead8a081"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#gaef9d8b5dd3d94847af102329ead8a081">lib_emt_copy2D2DLinked</a></div><div class="ttdeci">static int32_t lib_emt_copy2D2DLinked(lib_emt_Handle h, void *restrict src[], void *restrict dst[], int32_t num_bytes[], int32_t num_lines[], int32_t src_pitch[], int32_t dst_pitch[], int32_t num_transfers)</div><div class="ttdoc">Function lib_emt_copy2D2DLinked performs a group of linked 2D-&gt;2D transfers. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:616</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga624053012144128867ef2a9ef808f264"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga624053012144128867ef2a9ef808f264">lib_emt_copy2D2D</a></div><div class="ttdeci">static int32_t lib_emt_copy2D2D(lib_emt_Handle h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t src_pitch, int32_t dst_pitch)</div><div class="ttdoc">Function lib_emt_copy2D2D perform a 2D-&gt;2D transfer. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:504</div></div>
<div class="ttc" id="group__libarch__datatrans_html_gabe9856fed82fa0fc911a9fdb43e494e1"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#gabe9856fed82fa0fc911a9fdb43e494e1">lib_emt_copy1D1D</a></div><div class="ttdeci">static int32_t lib_emt_copy1D1D(lib_emt_Handle h, void *restrict src, void *restrict dst, int32_t num_bytes)</div><div class="ttdoc">Function lib_emt_copy1D1D performs a single 1D-&gt;1D data transfer in external memory. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:400</div></div>
<div class="ttc" id="group__libarch__utils_html_ga2dc4317fe6b9d654c7ec71eba4704bcd"><div class="ttname"><a href="../../de/d6b/group__libarch__utils.html#ga2dc4317fe6b9d654c7ec71eba4704bcd">lib_get_coreID</a></div><div class="ttdeci">static int lib_get_coreID()</div><div class="ttdoc">Function lib_get_coreID returns the DSP Core Number of the core currently executing this code...</div><div class="ttdef"><b>Definition:</b> lib_utils.h:51</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga6682ba347b624952140c5ead3301a8be"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga6682ba347b624952140c5ead3301a8be">LIB_EMT_SUCCESS</a></div><div class="ttdeci">#define LIB_EMT_SUCCESS</div><div class="ttdoc">Return error codes of external memory data transfer functions. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:160</div></div>
<div class="ttc" id="structlib__emt__ConfigLarge__s_html"><div class="ttname"><a href="../../d8/d98/structlib__emt__ConfigLarge__s.html">lib_emt_ConfigLarge_s</a></div><div class="ttdoc">Configuration for large external memory data transfers. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:204</div></div>
<div class="ttc" id="group__libarch__datatrans_html_ga8189ff38ebc25a3700ab04ffb612b1f2"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#ga8189ff38ebc25a3700ab04ffb612b1f2">lib_imt_set</a></div><div class="ttdeci">static void lib_imt_set(uint32_t pattern, void *dst, size_t size)</div><div class="ttdoc">Function lib_imt_set fills a block of internal memory, L1P, L1D, or L2 with a given pattern...</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:118</div></div>
<div class="ttc" id="structlib__emt__ConfigLarge__s_html_a0663257ebd151a0deda386e4b3a3bf48"><div class="ttname"><a href="../../d8/d98/structlib__emt__ConfigLarge__s.html#a0663257ebd151a0deda386e4b3a3bf48">lib_emt_ConfigLarge_s::max_num_lines</a></div><div class="ttdeci">int32_t max_num_lines</div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:206</div></div>
<div class="ttc" id="group__libarch__datatrans_html_gaae7bb385b41241410af0b5e917158e7b"><div class="ttname"><a href="../../d1/df3/group__libarch__datatrans.html#gaae7bb385b41241410af0b5e917158e7b">lib_emt_copy2D1DLinked</a></div><div class="ttdeci">static int32_t lib_emt_copy2D1DLinked(lib_emt_Handle h, void *restrict src[], void *restrict dst[], int32_t num_bytes[], int32_t num_lines[], int32_t pitch[], int32_t num_transfers)</div><div class="ttdoc">Function lib_emt_copy2D1DLinked performs a group of linked 2D-&gt;1D transfers. </div><div class="ttdef"><b>Definition:</b> lib_datatrans.h:587</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Mon Mar 6 2017 14:10:51 for LibArch by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="../../doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
